// TestUpdateDlgDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "TestUpdateDlg.h"
#include "TestUpdateDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTestUpdateDlgDlg Dialogfeld

CTestUpdateDlgDlg::CTestUpdateDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestUpdateDlgDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bMyStop = FALSE;
}

void CTestUpdateDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestUpdateDlgDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CTestUpdateDlgDlg Meldungshandler

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CTestUpdateDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CTestUpdateDlgDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CTestUpdateDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	SetTimer(MY_TIMER, 50, NULL);

	return TRUE;
}

void CTestUpdateDlgDlg::OnBnClickedOk()
{
	m_bMyStop = !m_bMyStop;

	if(!m_bMyStop)
	{
		SetTimer(MY_TIMER, 50, NULL);
	}
}

void CTestUpdateDlgDlg::OnTimer(UINT nIDEvent)
{
	if(MY_TIMER == nIDEvent)
	{
		KillTimer(MY_TIMER);
		GetDlgItem(IDOK)->SetWindowText(_T("Stop"));
		RunLoop();
	}
	CDialog::OnTimer(nIDEvent);
}

void CTestUpdateDlgDlg::RunLoop()
{
	MSG msg;
	m_bMyStop = FALSE;
	int i=0;
	while( !m_bMyStop )
	{
		CString stBuf;
		stBuf.Format(_T("%d"), i++);
		GetDlgItem(IDC_EDIT1)->SetWindowText(stBuf);
		if(i>100) i=0;
		while (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) AfxGetApp()->PumpMessage();
	}
	GetDlgItem(IDOK)->SetWindowText(_T("Start"));
}